<?php 
/**
 * 宝塔批量创建网站、绑定域名jio本
 * @author Youngxj 1170535111@qq.com
 * @time 2019年3月30日 13:39:16
 */
require_once('Bt.php');
// 修改成自己的宝塔接口和Api密钥
$bt = new Bt('http://127.0.0.1:8888','xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx');
header('Content-type: application/json');

// 批量执行的域名列表(请遵循次格式，请勿出现空格,换行等非常规操作)
$domainArr = 'test1.com,test2.com';


//使用宝塔创建网站(一站多域)
// $host = hostSetInfo($domainArr,'56',1,1);
// $AddSite = $bt->AddSite($host);


//使用宝塔创建网站(多站多域)
$AddSite = hostBuild($bt,$domainArr);


//使用宝塔批量添加域名
//$AddSite = $bt->WebAddDomain('宝塔站点ID','站点名',$domainArr);

//输出结果
echo json_encode($AddSite);


/**
 * 批量创建网站（多站多域）
 * @Author   Youngxj
 * @DateTime 2019-03-30
 * @param    [type]     $bt         无视
 * @param    [type]     $domainList 域名列表
 * @param    integer    $max        最大处理条数
 * @return   [type]                 Array
 */
function hostBuild($bt,$domainList,$max=100){
	$domains = explode(',',$domainList);
	
	$successNum = [];
	$errorNum = [];
	$num = 0;
	for ($i=0; $i < count($domains); $i++) { 
		if($num>$max){
			break;
		}
		$host = hostSetInfo($domains[$i],'56',1,1);
		$AddSite = $bt->AddSite($host);
		if(isset($AddSite['siteStatus'])){
			@$successNum['num']++;
			$successNum[] = $domains[$i];
		}else{
			@$errorNum['num']++;
			$errorNum[] = $domains[$i];
		}
		$num++;
	}
	return ['code' => '200','msg' => '批量执行完毕',['succ'=>$successNum,'error'=>$errorNum]];
}

/**
 * 站点信息批量生成
 * @Author   Youngxj
 * @DateTime 2019-03-30
 * @param    [type]     $domainList 域名组
 * @param    [type]     $php        php版本,56,72……
 * @param    [type]     $ftp        是否生成ftp
 * @param    [type]     $sql        是否生成sql
 * @param    string     $port       域名绑定端口
 * @param    string     $type_id    网站分类id
 * @return   [type]                 [description]
 */
function hostSetInfo($domainList,$php,$ftp,$sql,$port='80',$type_id='0'){
	$domains = explode(',',$domainList);

	$domainlist = array_shift($domains);

	$webname = json_encode(['domain'=>trim($domainlist),'domainlist'=>$domains,'count'=>count($domains)]);

	$hostSetInfo = array(
		'webname' => $webname,
		'path' => '/www/wwwroot/'.str_replace('.','_',$domainlist),
		'type_id' => $type_id,
		'type' => 'PHP',
		'version' => $php?$php:'00',
		'port' => $port,
		'codeing' => 'utf8',
		'ps' => $domainlist,
	);
	$hostSetInfo['ftp'] = $ftp?'true':'false';
	$hostSetInfo['ftp_username'] = $ftp?str_replace('.','_',$domainlist):'';
	$hostSetInfo['ftp_password'] = $ftp?random():'';
	
	$hostSetInfo['sql'] = $sql?'true':'false';
	$hostSetInfo['datauser'] = $sql?str_replace('.','_',$domainlist):'';
	$hostSetInfo['datapassword'] = $sql?random():'';
	
	return $hostSetInfo;
}

/**
 * 方法一：获取随机字符串
 * @param number $length 长度
 * @param string $type 类型
 * @param number $convert 转换大小写
 * @return string 随机字符串
 */
function random($length = 6, $type = 'string', $convert = 0)
{
	$config = array(
		'number' => '1234567890',
		'letter' => 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ',
		'string' => 'abcdefghjkmnpqrstuvwxyzABCDEFGHJKMNPQRSTUVWXYZ23456789',
		'all' => 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890'
	);

	if (!isset($config[$type]))
		$type = 'string';
	$string = $config[$type];

	$code = '';
	$strlen = strlen($string) - 1;
	for ($i = 0; $i < $length; $i++) {
		$code .= $string{mt_rand(0, $strlen)};
	}
	if (!empty($convert)) {
		$code = ($convert > 0) ? strtoupper($code) : strtolower($code);
	}
	return $code;
}